<?php

namespace GreenwayDirectService\StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for cardDetails StructType
 * @subpackage Structs
 */
class CardDetails extends AbstractStructBase
{
    /**
     * The cardType
     * @var string
     */
    public $cardType;
    /**
     * The cardNumber
     * @var mixed
     */
    public $cardNumber;
    /**
     * The expiryDate
     * @var mixed
     */
    public $expiryDate;
    /**
     * The holderName
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var mixed
     */
    public $holderName;
    /**
     * Constructor method for cardDetails
     * @uses CardDetails::setCardType()
     * @uses CardDetails::setCardNumber()
     * @uses CardDetails::setExpiryDate()
     * @uses CardDetails::setHolderName()
     * @param string $cardType
     * @param mixed $cardNumber
     * @param mixed $expiryDate
     * @param mixed $holderName
     */
    public function __construct($cardType = null, $cardNumber = null, $expiryDate = null, $holderName = null)
    {
        $this
            ->setCardType($cardType)
            ->setCardNumber($cardNumber)
            ->setExpiryDate($expiryDate)
            ->setHolderName($holderName);
    }
    /**
     * Get cardType value
     * @return string|null
     */
    public function getCardType()
    {
        return $this->cardType;
    }
    /**
     * Set cardType value
     * @uses \GreenwayDirectService\EnumType\CardType::valueIsValid()
     * @uses \GreenwayDirectService\EnumType\CardType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $cardType
     * @return \GreenwayDirectService\StructType\CardDetails
     */
    public function setCardType($cardType = null)
    {
        // validation for constraint: enumeration
        if (!\GreenwayDirectService\EnumType\CardType::valueIsValid($cardType)) {
            throw new \InvalidArgumentException(sprintf('Value "%s" is invalid, please use one of: %s', $cardType, implode(', ', \GreenwayDirectService\EnumType\CardType::getValidValues())), __LINE__);
        }
        $this->cardType = $cardType;
        return $this;
    }
    /**
     * Get cardNumber value
     * @return mixed|null
     */
    public function getCardNumber()
    {
        return $this->cardNumber;
    }
    /**
     * Set cardNumber value
     * @param mixed $cardNumber
     * @return \GreenwayDirectService\StructType\CardDetails
     */
    public function setCardNumber($cardNumber = null)
    {
        $this->cardNumber = $cardNumber;
        return $this;
    }
    /**
     * Get expiryDate value
     * @return mixed|null
     */
    public function getExpiryDate()
    {
        return $this->expiryDate;
    }
    /**
     * Set expiryDate value
     * @param mixed $expiryDate
     * @return \GreenwayDirectService\StructType\CardDetails
     */
    public function setExpiryDate($expiryDate = null)
    {
        $this->expiryDate = $expiryDate;
        return $this;
    }
    /**
     * Get holderName value
     * @return mixed|null
     */
    public function getHolderName()
    {
        return $this->holderName;
    }
    /**
     * Set holderName value
     * @param mixed $holderName
     * @return \GreenwayDirectService\StructType\CardDetails
     */
    public function setHolderName($holderName = null)
    {
        $this->holderName = $holderName;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \GreenwayDirectService\StructType\CardDetails
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
